var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var Creep = (function (_super) {
    __extends(Creep, _super);
    function Creep(gameplay, x, y, frame, health) {
        _super.call(this, gameplay.game, x, y, "creeps", frame);
        this.health = health;
        this.offset = new Phaser.Point(gameplay.game.rnd.integerInRange(-5, 5), gameplay.game.rnd.integerInRange(-5, 5));
        this.speed = gameplay.game.rnd.integerInRange(100, 150);
        this.scale.x = gameplay.game.rnd.realInRange(0.9, 1.1);
        //noinspection JSSuspiciousNameCombination
        this.scale.y = this.scale.x;
        gameplay.creepGroup.add(this);
        this.waypoint = 0;
        gameplay.game.physics.arcade.enableBody(this);
        this.gameplay = gameplay;
        this.anchor.set(0.5, 0.5);
        this.angle = 10;
        this.moveTween = this.gameplay.game.add.tween(this).to({ angle: -10 }, this.speed * 5, Phaser.Easing.Linear.None, true, 0, -1, true);
    }
    Creep.prototype.spawnStuff = function (frame) {
        var stuff = this.gameplay.game.add.sprite(this.x, this.y, "creepstuff", frame, this.gameplay.stuffGroup);
        this.gameplay.game.physics.arcade.enableBody(stuff);
        this.gameplay.game.add.tween(stuff).to({ alpha: 0 }, 700, Phaser.Easing.Linear.None, true, 700).onComplete.add(function () {
            this.destroy();
        }, stuff);
        stuff.body.angularVelocity = this.gameplay.game.rnd.integerInRange(-100, 100);
        stuff.body.velocity.y = this.gameplay.game.rnd.integerInRange(-40, -60);
        stuff.body.velocity.x = this.gameplay.game.rnd.integerInRange(-50, +50);
        stuff.body.gravity.y = 100;
    };
    Creep.prototype.kill = function () {
        this.spawnStuff(3);
        this.spawnStuff(3);
        this.spawnStuff(3);
        this.spawnStuff(3);
        this.spawnStuff(0);
        this.spawnStuff(0);
        this.spawnStuff(1);
        this.spawnStuff(2);
        return _super.prototype.kill.call(this);
    };
    Creep.prototype.update = function () {
        if (this.waypoint < this.gameplay.waypoints.length) {
            this.game.physics.arcade.moveToXY(this, this.gameplay.waypoints[this.waypoint].x + this.offset.x, this.gameplay.waypoints[this.waypoint].y + this.offset.y, this.speed);
            if (this.game.physics.arcade.distanceToXY(this, this.gameplay.waypoints[this.waypoint].x + this.offset.x, this.gameplay.waypoints[this.waypoint].y + this.offset.y) < 5) {
                this.waypoint++;
                if (this.waypoint >= this.gameplay.waypoints.length) {
                    this.gameplay.winnerGroup.add(this);
                    this.gameplay.loseLife();
                    this.angle = 0;
                    this.body.velocity.set(0, 0);
                    this.moveTween.stop();
                    this.moveTween = this.gameplay.add.tween(this).to({ y: this.y - 15 }, 1500, Phaser.Easing.Bounce.InOut, true, 0, -1, true);
                    this.gameplay.game.add.tween(this).to({ x: this.x + this.gameplay.game.rnd.integerInRange(-40, +40), y: this.y + this.gameplay.game.rnd.integerInRange(-20, +20) }, 1000, Phaser.Easing.Linear.None, true);
                    this.gameplay.winnerGroup.sort("y", Phaser.Group.SORT_ASCENDING);
                }
            }
        }
    };
    return Creep;
})(Phaser.Sprite);
//# sourceMappingURL=creep.js.map