/**
 * Created by JP on 06.12.2014.
 */
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var Game = (function (_super) {
    __extends(Game, _super);
    function Game() {
        _super.call(this, 1200, 768, Phaser.AUTO, "phaser", null);
        this.state.add("Gameplay", Gameplay, false);
        this.state.add("LoadingState", LoadingState, false);
        this.state.add("PreLoadingState", PreLoadingState, true);
    }
    return Game;
})(Phaser.Game);
var PreLoadingState = (function (_super) {
    __extends(PreLoadingState, _super);
    function PreLoadingState() {
        _super.apply(this, arguments);
    }
    PreLoadingState.prototype.preload = function () {
        this.game.load.image("loadingBackground", "assets/loadingBackground.png");
        this.game.load.image("loading", "assets/loading.png");
    };
    PreLoadingState.prototype.create = function () {
        this.game.state.start("LoadingState");
    };
    return PreLoadingState;
})(Phaser.State);
var LoadingState = (function (_super) {
    __extends(LoadingState, _super);
    function LoadingState() {
        _super.apply(this, arguments);
    }
    LoadingState.prototype.preload = function () {
        this.background = this.add.sprite(this.game.width / 2 - 288 / 2, this.game.height / 2 - 90 / 2, "loadingBackground");
        this.preloadBar = this.add.sprite(this.background.x, this.background.y, "loading");
        this.load.setPreloadSprite(this.preloadBar);
        //asset loading goes here
        this.game.load.image("level", "assets/level.png");
        this.game.load.image("levelgreen", "assets/levelgreen.png");
        this.game.load.spritesheet("creeps", "assets/creep.png", 42, 42);
        this.game.load.image("tower", "assets/tower.png");
        this.game.load.image("fire", "assets/fire.png");
        this.game.load.spritesheet("creepstuff", "assets/creepstuff21.png", 21, 21, 4);
        this.game.load.image("button", "assets/button.png");
        this.game.load.image("range", "assets/range.png");
        this.game.load.image("deco", "assets/deco.png");
    };
    LoadingState.prototype.create = function () {
        this.game.canvas.oncontextmenu = function (e) {
            e.preventDefault();
        };
        this.background.visible = false;
        this.game.stage.disableVisibilityChange = true;
        //this.add.tween(this.preloadBar.scale).to({x: 3, y:3}, 1000, Phaser.Easing.Linear.None, true);
        var tween = this.add.tween(this.preloadBar).to({ alpha: 0 }, 500, Phaser.Easing.Linear.None, true, 500);
        tween.onComplete.add(function () {
            this.preloadBar.destroy();
            this.game.state.start("Gameplay");
        }.bind(this));
    };
    return LoadingState;
})(Phaser.State);
window.onload = function () {
    new Game();
};
//# sourceMappingURL=game.js.map